package com.redxun.knowledge.task;

import com.redxun.knowledge.service.ActionLogServiceImpl;
import com.xxl.job.core.context.XxlJobHelper;
import com.xxl.job.core.handler.IJobHandler;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

@Component
@Slf4j
public class CountViewsJobHandler extends IJobHandler {

    @Autowired
    private ActionLogServiceImpl actionLogService;



    @Override
    @Transactional(rollbackFor = Exception.class)
    @XxlJob("countViewsHandler")
    public void execute() throws Exception {
        // 统计知识点击量
        boolean result = actionLogService.countViews();
        if (result){
            XxlJobHelper.handleSuccess("执行成功!");
            actionLogService.deleteCountViews();
        } else {
            XxlJobHelper.handleFail("执行失败!");
        }
    }
}