package com.redxun.knowledge.utils;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import java.util.ArrayList;
import java.util.List;

/**
 * 文件名: PageListUtils
 * 作者: Zizg
 * 时间: 2023/1/3
 * 描述:
 * 修改人:
 * 修改时间:
 * 修改内容:
 */
public class PageListUtils {
    /**
     * 分页
     * @param currentPage   当前页数
     * @param pageSize  每一页的数据条数
     * @param list  要进行分页的数据列表
     * @return  当前页要展示的数据
     */
    public static Page getPages(long currentPage, long pageSize, List list) {
        Page page = new Page();
        int size = list.size();

        if(pageSize > size) {
            pageSize = size;
        }

        // 求出最大页数，防止currentPage越界
        long maxPage = 0;
        if (pageSize != 0){
            maxPage = size % pageSize == 0 ? size / pageSize : size / pageSize + 1;
        }

        if(currentPage > maxPage) {
            currentPage = maxPage;
        }

        // 当前页第一条数据的下标
        long curIdx = currentPage > 1 ? (currentPage - 1) * pageSize : 0;

        List pageList = new ArrayList();

        // 将当前页的数据放进pageList
        for(long i = 0; i < pageSize && curIdx + i < size; i++) {
            pageList.add(list.get((int) (curIdx + i)));
        }

        page.setCurrent(currentPage).setSize(pageSize).setTotal(list.size()).setRecords(pageList);
        return page;
    }
}